//GLOBAL
var NOTOPCODE=0x100000000,YET=0x100000000+1;
var COMMENT=0x100000000+2,EMPTYLINE=0x100000000+3;
var ASMERR=0x100000000+4,LABEL=0x100000000+5;
var lbl_dict={};
var token_dict={
"@":"@",
"reg":"r([0-7])",
"!":"\\!",
"=":"=",
"<<":"<<",
">>":">>",
"+":"\\+",
"|":"\\|",
//"n":"((?:\\-|0b|0x)?[0-0a-f]{1,8})",
"n":"(.+)",
"-":"\\-",
"&":"&",
"^":"\\^",
"not":"(?:\\~|not)",

"*":"\\*",
"if":"if",
"goto":"goto",
"ret":"ret",
"":"",
"[":"\\[",
"]":"\\]",
"0":"0"
}



function patfactory(s){

    s=s.split(" ");
    var p=["^"],i;
    for(i=0;i<s.length;i++){
        p.push(token_dict[s[i].toLowerCase()]);
    }
	p.push("$");
	return RegExp(p.join(""));
}
var b_dict={};
var n_dict={};

function n(bits,s,ofs){
	//dat bit shift
	ofs=(ofs!=undefined)?ofs:0;
	
	var mask=Math.pow(2,bits)-1;
	var mx=Math.pow(2,bits-1)-1;
	var mn=-Math.pow(2,bits-1);
	if(mask<1) mask=0;
	var f=function(d,pc){
		var ret,lbl,i;
		ret=d.match(/@\w+/g);
		if (ret!=null){
			for(i=0;i<ret.length;i++){
				lbl=ret[i];
				if ( lbl in lbl_dict){
					rel=(lbl_dict[lbl]-pc)/2;
					if (rel>mx||rel<mn){
						return ASMERR
					}
					d=d.replace(lbl,rel,"g")
				}else{
					return YET;
				}
			}
		}
		d=parseInt(eval(d))+ofs;
		return (d&mask)<<s;
	}
	return f;
}
function b(bits,s,ofs){
	//dat bit shift,ofs
	ofs=(ofs!=undefined)?ofs:0;
	var mask=Math.pow(2,bits)-1;
	if(mask<1) mask=0;
	var f=function(d,pc){
		//console.log(bits,s,ofs);
		d=parseInt(d);

		return (d&mask)<<s;
	}

	return f;

}
function build_m(f,ar,pc){
	var i,op=f[1],_op;

		for(i=1;i<ar.length;i++){
			_op=f[i+1](ar[i],pc);
			if (_op>=NOTOPCODE){
				return _op;
			}else{
				op=op|_op;
			}
		}
		return 0x0ffff&op;
}


var cmdlist=[
//label

//jmp
["if 0 goto n",0xd000,n(8,0,-2)],
["if ! 0 goto n",0xd100,n(8,0,-2)],
["goto n",0xe000,n(11,0,-2)],

//memory
["reg = [ reg + reg ]",0x5c00,b(3,0),b(3,3),b(3,6)],
["reg = [ reg + n ]",0x7800,b(3,0),b(3,3),b(5,6,0)],
["[ reg + reg ] = reg",0x5400,b(3,3),b(3,6),b(3,0)],
["[ reg + n ] = reg",0x7000,b(3,3),b(5,6,0),b(3,0)],//calc
["reg + = n",0x3000,b(3,8),b(8,0)],
["reg - = n",0x3800,b(3,8),b(8,0)],
["reg = reg << n",0x0,b(3,0),b(3,3),b(5,6)],
["reg = reg >> n",0x0800,b(3,0),b(3,3),b(5,6)],
["reg = reg + reg",0x1800,b(3,0),b(3,3),b(3,6)],
["reg = reg - reg",0x1a00,b(3,0),b(3,3),b(3,6)],
["reg = reg + n",0x1c00,b(3,0),b(3,3),b(3,6)],
["reg = reg - n",0x1e00,b(3,0),b(3,3),b(3,6)],
["reg & = reg",0x4000,b(3,0),b(3,3)],
["reg ^ = reg",0x4040,b(3,0),b(3,3)],
["reg << = reg",0x4080,b(3,0),b(3,3)],
["reg >> = reg",0x40c0,b(3,0),b(3,3)],
["reg = - reg",0x4240,b(3,0),b(3,3)],
["reg | = reg",0x4300,b(3,0),b(3,3)],
["reg * = reg",0x4340,b(3,0),b(3,3)],
["reg & = not reg",0x4380,b(3,0),b(3,3)],
["reg = not reg",0x43c0,b(3,0),b(3,3)],
//cmp
["reg - n",0x2800,b(3,8),b(8,0)],
["reg - reg",0x4280,b(3,0),b(3,3)],
["reg & reg",0x4200,b(3,0),b(3,3)],
["ret",0x4770],
//let
["reg = reg",0x4600,b(3,0),b(3,3)],
["reg = n",0x2000,b(3,8),b(8,0,0)]
];

var patlist=[];
var i=0;
for(i=0;i<cmdlist.length;i++){
	patlist.push(patfactory(cmdlist[i][0]));
}
function zero8(x){
	var p=x.toString(2);
	p="00000000".substr(0,8-p.length)+p;
	return p;
}
function m2b(lines,outlist){
	var p,p0,p1;
	var bas="",i,line,out,nln;
	var skips={undefined:true,LABEL:true,COMMENT:true,NOTOPCODE:true};
	for(i=0; i<lines.length; i++){
		line=lines[i];
		out=outlist[i];
		a=out[0];
		p=out[1];
		if(p==EMPTYLINE){
			continue;
		}else if(!p ||p>=NOTOPCODE){
			nln=i*10+10;
			bas+=""+nln+"'"+line+"\n";
		}else{

			p0=p&0x0ff; p1=(p>>8)&0x0ff
			p0=zero8(p0);p1=zero8(p1);
			nln=i*10+10;
			bas+=""+nln+" "+"poke #"+a.toString(16)+
			",`"+p0+",`"+p1+
			" :'"+line+"\n";
		}
	}
	return bas;
}

function asmln(ln,prgctr){



	var p,m,j;
	//ln=ln.toLowerCase().replace(/\s/g,"");
	for(j=0;j<patlist.length;j++){
		m=ln.match(patlist[j]);
		if(m){
			console.log(cmdlist[j][0]);
			p=build_m(cmdlist[j],m,prgctr);
			return p;
		}
	}
	return undefined;

}
var bas="";
var outlist={};
function asemble(){
var PrgCtr=0;
dom_src=document.getElementById("textarea1");
dom_hex=document.getElementById("textarea2");
dom_err=document.getElementById("textarea3");
	var lines=(""+dom_src.value).split("\n");
	var i,j,line,m,p;
	
	dom_hex.innerHTML=""
	PrgCtr=0x700;
	bas="";
	for(i=0;i<lines.length;i++){
		line=lines[i].toLowerCase().replace(/\s/g,"");
		lines[i]=line;

		if (line.charAt(0)=="@"){
			lbl_dict[line]=PrgCtr;
			outlist[i]=[PrgCtr,LABEL];
			continue;
		}else if(line.charAt(0)=="'"||line.slice(0,3)=="rem"){

			outlist[i]=[PrgCtr,COMMENT];
			continue;
		} else if(line==""){

			outlist[i]=[PrgCtr,EMPTYLINE];
			continue;
			

		}else{
			p=asmln(line,PrgCtr);
			outlist[i]=[PrgCtr,p];
			if (p!=undefined){
				PrgCtr+=2;
			}
		}
	}
	
	for(i=0;i<lines.length;i++){

		line=lines[i];

		PrgCtr=outlist[i][0];
		p=outlist[i][1];
		if (p>=NOTOPCODE){

		}
		if(p==YET){

			p=asmln(line,PrgCtr);
			outlist[i]=[PrgCtr,p]
		}
	}
	bas=m2b(lines,outlist);
	dom_hex.value=bas;
	if(dom_hex.textContent==bas) return;
	dom_hex.textContent=bas;
	if(dom_hex.textContent==bas) return;
	dom_hex.innerText=bas;
	if(dom_hex.innerText==bas) return;
	dom_hex.innerHTML=bas;
	if(dom_hex.innerHTML==bas) return;

}


